﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.ModelBinding;
using System.Web.Http.OData;
using System.Web.Http.OData.Routing;
using MvcApplication4.Models;
using System.Data.SqlClient;
using System.Web.Http.OData.Query;

namespace MvcApplication4.Controllers
{
    /*
    To add a route for this controller, merge these statements into the Register method of the WebApiConfig class. Note that OData URLs are case sensitive.

    using System.Web.Http.OData.Builder;
    using MvcApplication4.Models;
    ODataConventionModelBuilder builder = new ODataConventionModelBuilder();
    builder.EntitySet<Order>("Orders");
    config.Routes.MapODataRoute("odata", "odata", builder.GetEdmModel());
    */
    public class OrdersController : ODataController
    {
        private IQueryable<Order> ord = new DataClasses1DataContext().Orders    ;
        // GET odata/Orders
        [Queryable]
        public IQueryable<Order> Get(ODataQueryOptions  opt)
        {
            return ord; //Datasource of MVC Grid
        }

        // PUT odata/Orders(5)
        public IHttpActionResult Put(Order temp) //Edit operation in database
        {
                string ConnectionString = @"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\NORTHWND.mdf;Integrated Security=True"; ;

                var myConnection = new SqlConnection(ConnectionString);
                myConnection.Open();
                SqlCommand command1 = new SqlCommand();
                command1.Connection = myConnection;
                command1.CommandText = @"UPDATE Orders SET EmployeeID = @employeeID, ShipCity = @shipCity WHERE OrderID=" + temp.OrderID;

                command1.Parameters.AddWithValue("@shipCity", temp.ShipCity);

                command1.Parameters.AddWithValue("@employeeID", temp.EmployeeID);

                command1.ExecuteNonQuery();

                myConnection.Close();
            

            return Updated(ord);
        }

        //// POST odata/Orders
        public IHttpActionResult Post(Order order) //Add Operation in database
        {
            string ConnectionString = @"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\NORTHWND.mdf;Integrated Security=True"; ;

            var myConnection = new SqlConnection(ConnectionString);
            myConnection.Open();
            SqlCommand command1 = new SqlCommand();
            command1.Connection = myConnection;
            command1.CommandText = @"SET IDENTITY_INSERT Orders ON; INSERT Orders(EmployeeID,ShipCity,OrderID) VALUES(@employeeID,@shipCity,@orderID);SET IDENTITY_INSERT Orders OFF";
            command1.Parameters.AddWithValue("@orderID", order.OrderID); 
            command1.Parameters.AddWithValue("@shipCity", order.ShipCity);

            command1.Parameters.AddWithValue("@employeeID", order.EmployeeID);
            command1.ExecuteNonQuery();
            myConnection.Close();
            return Created(order);
        }


        //// DELETE odata/Orders(5)
        public IHttpActionResult Delete([FromODataUri] int key) //Delete Operation in Database
        {
            Order order = ord.First(c => c.OrderID == key);
            if (order == null)
            {
                return NotFound();
            }

            string ConnectionString = @"Data Source=(LocalDB)\v11.0;AttachDbFilename=|DataDirectory|\NORTHWND.mdf;Integrated Security=True"; ;

            var myConnection = new SqlConnection(ConnectionString);
            myConnection.Open();
            SqlCommand command1 = new SqlCommand();
            command1.Connection = myConnection;
            command1.CommandText = @"DELETE FROM [Orders] WHERE OrderID=" + key;

            command1.ExecuteNonQuery();
            myConnection.Close();

            return StatusCode(HttpStatusCode.NoContent);
        }
    }
}
